﻿import es
import langlib
import playerlib
import popuplib

addon = es.import_addon("soccer_mod_2011/admin/settings")

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

messages_common = langlib.Strings(lang_dir + "messages_common.ini")
messages_text = langlib.Strings(lang_dir + "admin/settings/messages_settings_match_main.ini")
popup_common = langlib.Strings(lang_dir + "popup_common.ini")
popup_text = langlib.Strings(lang_dir + "admin/settings/popup_settings_match_main.ini")

settings_main = ["sounds", "public_start", "public_pause", "public_stop", "swap_names", "score_board", "golden_goal"]

# ******************** Load ********************
def load():
	for item in settings_main:
		es.set("sm_match_%s_on" % (item), int(es.keygetvalue("soccer_mod_settings", "match", item)))

	popup = popuplib.create("sm_popup_admin_settings_match_main")

	popup.addline("SOCCER MOD %s" % (popup_text("title")))
	popup.addline(" ")

	for i in range(0, len(settings_main)):
		if es.ServerVar("sm_match_%s_on" % (settings_main[i])) == 1:
			value = popup_common("on")
		else:
			value = popup_common("off")

		popup.addline("->%s. %s: %s" % (i + 1, popup_text(settings_main[i]), value))
		popup.select(i + 1, change_setting_main)

	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (popup_common("close")))

	popup.submenu(8, "sm_popup_admin_settings_match_main")
	popup.submenu(9, "sm_popup_admin_settings_match")

# ******************** Popup choice ********************
def change_setting_main(userid, choice, popupid):
	addon.set_boolean(userid, "match_main", "match", settings_main[choice - 1], popupid, choice)

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_admin_settings_match_main")