﻿import es
import langlib
import playerlib
import popuplib

addon = es.import_addon("soccer_mod_2011/admin/settings")

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

messages_common = langlib.Strings(lang_dir + "messages_common.ini")
messages_text = langlib.Strings(lang_dir + "admin/settings/messages_settings_match_time.ini")
popup_common = langlib.Strings(lang_dir + "popup_common.ini")
popup_text = langlib.Strings(lang_dir + "admin/settings/popup_settings_match_time.ini")

settings_time = ["periods", "restart_length", "period_length", "period_break_length"]

# ******************** Load ********************
def load():
	for item in settings_time:
		es.set("sm_match_%s" % (item), int(es.keygetvalue("soccer_mod_settings", "match", item)))

	popup = popuplib.create("sm_popup_admin_settings_match_time")

	popup.addline("SOCCER MOD %s" % (popup_text("title")))
	popup.addline(" ")

	for i in range(0, len(settings_time)):
		popup.addline("->%s. %s: %s" % (i + 1, popup_text(settings_time[i]), es.ServerVar("sm_match_%s" % (settings_time[i]))))
		popup.select(i + 1, change_setting_time)

	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (popup_common("close")))

	for i in range(5, 9):
		popup.submenu(i, "sm_popup_admin_settings_match_time")

	popup.submenu(9, "sm_popup_admin_settings_match")

	es.addons.registerSayFilter(filter)

# ******************** Popup choice ********************
def change_setting_time(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if es.ServerVar("sm_match_started") == 0:
		if es.exists("key", "sm_keygroup_set", player.steamid) == 0:
			es.keycreate("sm_keygroup_set", player.steamid)

		es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "settings_match_time_%s" % (settings_time[choice - 1]))
		es.tell(userid, "#green", messages_text("type_%s" % (settings_time[choice - 1]), tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages_common("no_option_match", tokens, player.get("lang")))
		popuplib.send("sm_popup_admin_settings_match_time", userid)

# ******************** Say filter ********************
def filter(userid, text, teamonly):
	steamid = es.getplayersteamid(userid)

	if es.exists("key", "sm_keygroup_set", steamid) == 1:
		type = es.keygetvalue("sm_keygroup_set", steamid, "setting_type")
		text = text.strip('"')

		if type == "settings_match_time_periods":
			addon.set_number(userid, text, "match_time", "match", "periods", 0, 1, 10, "sm_popup_admin_settings_match_time", 1)
			return (0, None, 0)

		elif type == "settings_match_time_restart_length":
			addon.set_number(userid, text, "match_time", "match", "restart_length", 0, 1, 60, "sm_popup_admin_settings_match_time", 2)
			return (0, None, 0)

		elif type == "settings_match_time_period_length":
			addon.set_number(userid, text, "match_time", "match", "period_length", 0, 1, 10000, "sm_popup_admin_settings_match_time", 3)
			return (0, None, 0)

		elif type == "settings_match_time_period_break_length":
			addon.set_number(userid, text, "match_time", "match", "period_break_length", 0, 1, 10000, "sm_popup_admin_settings_match_time", 4)
			return (0, None, 0)

		else:
			return (userid, text, teamonly)
	else:
		return (userid, text, teamonly)

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_admin_settings_match_time")

	es.addons.unregisterSayFilter(filter)