﻿import cmdlib
import es

modules = ["cap", "health", "match", "referee", "respawn", "scoreboard", "shout", "skins", "sprint", "stats", "training", "vote"]

# ******************** Load ********************
def load():
	es.set("sm_downloads_on", 1)
	es.set("sm_downloads_auto_on", 1)

	cmdlib.registerServerCommand("soccer_mod_downloads_on", downloads, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_automatic_downloads_on", automatic_downloads, "Server Command")

	reg("sm_command_admin", "!menu", "soccer_mod_2011/admin/cmd_admin")
	reg("sm_command_info", "!info", "soccer_mod_2011/info/cmd_info")

	cmdlib.registerServerCommand("soccer_mod_command_admin", command_admin, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_command_info", command_info, "Server Command")

	es.set("sm_check_latest_version_on", 1)

	cmdlib.registerServerCommand("soccer_mod_check_latest_version_on", check_latest_version, "Server Command")

	es.set("sm_module_cap_on", 1)
	es.set("sm_module_match_on", 1)
	es.set("sm_module_health_on", 1)
	es.set("sm_module_referee_on", 1)
	es.set("sm_module_respawn_on", 1)

	es.set("sm_module_scoreboard_on", 1)
	es.set("sm_module_shout_on", 1)
	es.set("sm_module_skins_on", 1)
	es.set("sm_module_sprint_on", 1)
	es.set("sm_module_stats_on", 1)

	es.set("sm_module_training_on", 1)
	es.set("sm_module_vote_on", 1)

	cmdlib.registerServerCommand("soccer_mod_module_cap_on", module_cap, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_module_match_on", module_match, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_module_health_on", module_health, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_module_referee_on", module_referee, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_module_respawn_on", module_referee, "Server Command")

	cmdlib.registerServerCommand("soccer_mod_module_scoreboard_on", module_scoreboard, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_module_shout_on", module_shout, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_module_skins_on", module_skins, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_module_sprint_on", module_sprint, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_module_stats_on", module_stats, "Server Command")

	cmdlib.registerServerCommand("soccer_mod_module_training_on", module_training, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_module_vote_on", module_vote, "Server Command")

	es.server.cmd("exec soccer_mod/soccer_mod.cfg")

	for item in modules:
		if es.ServerVar("sm_module_%s_on" % (item)) == 1:
			es.load("soccer_mod_2011/cfg/%s" % (item))

# ******************** Events ********************
def es_map_start(event_var):
	if es.exists("key", "soccer_mod_maps", event_var["mapname"]) == 1:
		es.set("soccer_mod_allowed", 1)

		es.doblock("soccer_mod_2011/downloads/refresh")
	else:
		es.set("soccer_mod_allowed", 0)

# ******************** Commands ********************
def downloads(args):
	boolean("sm_downloads_on", args[0])

def automatic_downloads(args):
	boolean("sm_downloads_auto_on", args[0])

def command_admin(args):
	unreg("sm_command_admin")
	reg("sm_command_admin", args[0], "soccer_mod_2011/admin/cmd_admin")

def command_info(args):
	unreg("sm_command_info")
	reg("sm_command_info", args[0], "soccer_mod_2011/info/cmd_info")

def check_latest_version(args):
	boolean("sm_check_latest_version_on", args[0])

def module_cap(args):
	boolean("sm_module_cap_on", args[0])

def module_match(args):
	boolean("sm_module_match_on", args[0])

def module_health(args):
	boolean("sm_module_health_on", args[0])

def module_referee(args):
	boolean("sm_module_referee_on", args[0])

def module_respawn(args):
	boolean("sm_module_respawn_on", args[0])

def module_scoreboard(args):
	boolean("sm_module_scoreboard_on", args[0])

def module_shout(args):
	boolean("sm_module_shout_on", args[0])

def module_skins(args):
	boolean("sm_module_skins_on", args[0])

def module_sprint(args):
	boolean("sm_module_sprint_on", args[0])

def module_stats(args):
	boolean("sm_module_stats_on", args[0])

def module_training(args):
	boolean("sm_module_training_on", args[0])

def module_vote(args):
	boolean("sm_module_vote_on", args[0])

# ******************** Functions ********************
def reg(name, cmd, block):
	es.set(name, cmd)

	if es.exists("saycommand", cmd) == 0:
		es.regsaycmd(cmd, block)

	if es.exists("clientcommand", cmd) == 0:
		es.regclientcmd(cmd, block)

def unreg(name):
	cmd = es.ServerVar(name)

	if es.exists("saycommand", cmd) == 1:
		es.unregsaycmd(cmd)

	if es.exists("clientcommand", cmd) == 1:
		es.unregclientcmd(cmd)

def boolean(name, value):
	try:
		if int(value) == 1:
			es.set(name, 1)
		else:
			es.set(name, 0)
	except ValueError:
		es.set(name, 0)

def integer(name, value, min, max, default):
	try:
		value = int(value)
		if value >= min and value <= max:
			es.set(name, value)
		else:
			es.set(name, default)
	except ValueError:
		es.set(name, default)

def float(name, value, min, max, default):
	try:
		value = float(value)
		if value >= min and value <= max:
			es.set(name, value)
		else:
			es.set(name, default)
	except ValueError:
		es.set(name, default)

# ******************** Unload ********************
def unload():
	cmdlib.unregisterServerCommand("soccer_mod_downloads_on")
	cmdlib.unregisterServerCommand("soccer_mod_automatic_downloads_on")

	cmdlib.unregisterServerCommand("soccer_mod_command_admin")
	cmdlib.unregisterServerCommand("soccer_mod_command_info")

	cmdlib.unregisterServerCommand("soccer_mod_check_latest_version_on")

	cmdlib.unregisterServerCommand("soccer_mod_module_cap_on")
	cmdlib.unregisterServerCommand("soccer_mod_module_match_on")
	cmdlib.unregisterServerCommand("soccer_mod_module_health_on")
	cmdlib.unregisterServerCommand("soccer_mod_module_referee_on")
	cmdlib.unregisterServerCommand("soccer_mod_module_respawn_on")

	cmdlib.unregisterServerCommand("soccer_mod_module_scoreboard_on")
	cmdlib.unregisterServerCommand("soccer_mod_module_shout_on")
	cmdlib.unregisterServerCommand("soccer_mod_module_skins_on")
	cmdlib.unregisterServerCommand("soccer_mod_module_sprint_on")
	cmdlib.unregisterServerCommand("soccer_mod_module_stats_on")

	cmdlib.unregisterServerCommand("soccer_mod_module_training_on")
	cmdlib.unregisterServerCommand("soccer_mod_module_vote_on")

	unreg("sm_command_admin")
	unreg("sm_command_info")

	for item in modules:
		if es.ServerVar("sm_module_%s_on" % (item)) == 1:
			es.unload("soccer_mod_2011/cfg/%s" % (item))