﻿import cmdlib
import es

addon = es.import_addon("soccer_mod_2011/cfg")

# ******************** Load ********************
def load():
	es.set("sm_match_sound_round_start", "soccer_mod/match/kickoff.wav")
	es.set("sm_match_sound_round_end", "soccer_mod/match/wickedsick.mp3")
	es.set("sm_match_sound_period_end", "soccer_mod/match/halftime.wav")
	es.set("sm_match_sound_match_end", "soccer_mod/match/endmatch.wav")

	cmdlib.registerServerCommand("soccer_mod_match_sound_round_start", sound_round_start, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_sound_round_end", sound_round_end, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_sound_period_end", sound_period_end, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_sound_match_end", sound_match_end, "Server Command")

	addon.reg("sm_match_command_start", "!start", "soccer_mod_2011/modules/match/cmd_start")
	addon.reg("sm_match_command_pause", "!pause", "soccer_mod_2011/modules/match/cmd_pause")
	addon.reg("sm_match_command_unpause", "!unpause", "soccer_mod_2011/modules/match/cmd_unpause")
	addon.reg("sm_match_command_stop", "!stop", "soccer_mod_2011/modules/match/cmd_stop")

	cmdlib.registerServerCommand("soccer_mod_match_command_start", command_start, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_command_pause", command_pause, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_command_unpause", command_unpause, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_command_stop", command_stop, "Server Command")

# ******************** Commands ********************
def sound_round_start(args):
	es.set("sm_match_sound_round_start", args[0])

def sound_round_end(args):
	es.set("sm_match_sound_round_end", args[0])

def sound_period_end(args):
	es.set("sm_match_sound_period_end", args[0])

def sound_match_end(args):
	es.set("sm_match_sound_match_end", args[0])

def command_start(args):
	addon.unreg("sm_match_command_start")
	addon.reg("sm_match_command_start", args[0], "soccer_mod_2011/modules/match/cmd_start")

def command_pause(args):
	addon.unreg("sm_match_command_pause")
	addon.reg("sm_match_command_pause", args[0], "soccer_mod_2011/modules/match/cmd_pause")

def command_unpause(args):
	addon.unreg("sm_match_command_unpause")
	addon.reg("sm_match_command_unpause", args[0], "soccer_mod_2011/modules/match/cmd_unpause")

def command_stop(args):
	addon.unreg("sm_match_command_stop")
	addon.reg("sm_match_command_stop", args[0], "soccer_mod_2011/modules/match/cmd_stop")

# ******************** Unload ********************
def unload():
	cmdlib.unregisterServerCommand("soccer_mod_match_sound_round_start")
	cmdlib.unregisterServerCommand("soccer_mod_match_sound_round_end")
	cmdlib.unregisterServerCommand("soccer_mod_match_sound_period_end")
	cmdlib.unregisterServerCommand("soccer_mod_match_sound_match_end")

	cmdlib.unregisterServerCommand("soccer_mod_match_command_start")
	cmdlib.unregisterServerCommand("soccer_mod_match_command_pause")
	cmdlib.unregisterServerCommand("soccer_mod_match_command_unpause")
	cmdlib.unregisterServerCommand("soccer_mod_match_command_stop")

	addon.unreg("sm_match_command_start")
	addon.unreg("sm_match_command_pause")
	addon.unreg("sm_match_command_unpause")
	addon.unreg("sm_match_command_stop")