﻿import cmdlib
import es

addon = es.import_addon("soccer_mod_2011/cfg")

# ******************** Load ********************
def load():
	es.set("sm_shout_delay", 3)

	cmdlib.registerServerCommand("soccer_mod_shout_delay", delay, "Server Command")

	es.set("sm_shout_sound_foul", "soccer_mod/shout/rampage.mp3")
	es.set("sm_shout_sound_goal", "soccer_mod/shout/unstoppable.mp3")
	es.set("sm_shout_sound_ole", "soccer_mod/shout/humiliation.mp3")
	es.set("sm_shout_sound_pass", "soccer_mod/shout/teamkiller.mp3")
	es.set("sm_shout_sound_save", "soccer_mod/shout/godlike.mp3")
	es.set("sm_shout_sound_shot", "soccer_mod/shout/holyshit.mp3")

	cmdlib.registerServerCommand("soccer_mod_shout_sound_foul", sound_foul, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_shout_sound_goal", sound_goal, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_shout_sound_ole", sound_ole, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_shout_sound_pass", sound_pass, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_shout_sound_save", sound_save, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_shout_sound_shot", sound_shot, "Server Command")

	addon.reg("sm_shout_command", "!shout", "soccer_mod_2011/modules/shout/cmd_shout")

	cmdlib.registerServerCommand("soccer_mod_shout_command", command, "Server Command")

# ******************** Commands ********************
def command(args):
	addon.unreg("sm_shout_command")
	addon.reg("sm_shout_command", args[0], "soccer_mod_2011/modules/shout/cmd_shout")

def delay(args):
	addon.integer("sm_shout_delay", args[0], 1, 60, 3)

def sound_foul(args):
	es.set("sm_shout_sound_foul", args[0])

def sound_goal(args):
	es.set("sm_shout_sound_goal", args[0])

def sound_ole(args):
	es.set("sm_shout_sound_ole", args[0])

def sound_pass(args):
	es.set("sm_shout_sound_pass", args[0])

def sound_save(args):
	es.set("sm_shout_sound_save", args[0])

def sound_shot(args):
	es.set("sm_shout_sound_shot", args[0])

# ******************** Unload ********************
def unload():
	cmdlib.unregisterServerCommand("soccer_mod_shout_command")
	cmdlib.unregisterServerCommand("soccer_mod_shout_delay")

	cmdlib.unregisterServerCommand("soccer_mod_shout_sound_foul")
	cmdlib.unregisterServerCommand("soccer_mod_shout_sound_goal")
	cmdlib.unregisterServerCommand("soccer_mod_shout_sound_ole")
	cmdlib.unregisterServerCommand("soccer_mod_shout_sound_pass")
	cmdlib.unregisterServerCommand("soccer_mod_shout_sound_save")
	cmdlib.unregisterServerCommand("soccer_mod_shout_sound_shot")

	addon.unreg("sm_shout_command")