﻿import cmdlib
import es

addon = es.import_addon("soccer_mod_2011/cfg")

# ******************** Load ********************
def load():
	es.set("sm_stats_rank_save_round_end_on", 0)

	cmdlib.registerServerCommand("soccer_mod_stats_rank_save_round_end", rank_save_round_end, "Server Command")

	es.set("sm_stats_rank_goal", 25)
	es.set("sm_stats_rank_assist", 10)
	es.set("sm_stats_rank_own_goal", -25)
	es.set("sm_stats_rank_hit", 1)
	es.set("sm_stats_rank_pass", 5)
	es.set("sm_stats_rank_interception", 3)
	es.set("sm_stats_rank_loss", -5)
	es.set("sm_stats_rank_multiplier", 5)

	cmdlib.registerServerCommand("soccer_mod_stats_rank_goal", rank_goal, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_stats_rank_assist", rank_assist, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_stats_rank_own_goal", rank_own_goal, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_stats_rank_hit", rank_hit, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_stats_rank_pass", rank_pass, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_stats_rank_interception", rank_interception, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_stats_rank_loss", rank_loss, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_stats_rank_multiplier", rank_multiplier, "Server Command")

	addon.reg("sm_stats_command_stats", "!stats", "soccer_mod_2011/modules/stats/cmd_stats")
	addon.reg("sm_stats_command_stats_clear", "!clear_personal_stats", "soccer_mod_2011/modules/stats/ranking/cmd_stats_clear")

	cmdlib.registerServerCommand("soccer_mod_stats_command_menu", command_stats, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_stats_command_clear", command_stats_clear, "Server Command")

# ******************** Commands ********************
def rank_save_round_end(args):
	addon.boolean("sm_stats_rank_save_round_end_on", args[0])

def rank_goal(args):
	addon.integer("sm_stats_rank_goal", args[0], -100, 100, 25)

def rank_assist(args):
	addon.integer("sm_stats_rank_assist", args[0], -100, 100, 10)

def rank_own_goal(args):
	addon.integer("sm_stats_rank_own_goal", args[0], -100, 100, -25)

def rank_hit(args):
	addon.integer("sm_stats_rank_hit", args[0], -100, 100, 1)

def rank_pass(args):
	addon.integer("sm_stats_rank_pass", args[0], -100, 100, 5)

def rank_interception(args):
	addon.integer("sm_stats_rank_interception", args[0], -100, 100, 3)

def rank_loss(args):
	addon.integer("sm_stats_rank_loss", args[0], -100, 100, -5)

def rank_multiplier(args):
	addon.integer("sm_stats_rank_multiplier", args[0], 1, 10, 5)

def command_stats(args):
	addon.unreg("sm_stats_command_stats")
	addon.reg("sm_stats_command_stats", args[0], "soccer_mod_2011/modules/stats/cmd_stats")

def command_stats_clear(args):
	addon.unreg("sm_stats_command_stats_clear")
	addon.reg("sm_stats_command_stats_clear", args[0], "soccer_mod_2011/modules/stats/ranking/cmd_stats_clear")

# ******************** Unload ********************
def unload():
	cmdlib.unregisterServerCommand("soccer_mod_stats_rank_save_round_end")

	cmdlib.unregisterServerCommand("soccer_mod_stats_rank_goal")
	cmdlib.unregisterServerCommand("soccer_mod_stats_rank_assist")
	cmdlib.unregisterServerCommand("soccer_mod_stats_rank_own_goal")
	cmdlib.unregisterServerCommand("soccer_mod_stats_rank_hit")
	cmdlib.unregisterServerCommand("soccer_mod_stats_rank_pass")
	cmdlib.unregisterServerCommand("soccer_mod_stats_rank_interception")
	cmdlib.unregisterServerCommand("soccer_mod_stats_rank_loss")
	cmdlib.unregisterServerCommand("soccer_mod_stats_rank_multiplier")

	cmdlib.unregisterServerCommand("soccer_mod_stats_command_menu")
	cmdlib.unregisterServerCommand("soccer_mod_stats_command_clear")

	addon.unreg("sm_stats_command_stats")
	addon.unreg("sm_stats_command_stats_clear")