﻿import cmdlib
import es

addon = es.import_addon("soccer_mod_2011/cfg")

# ******************** Load ********************
def load():
	es.set("sm_vote_public_on", 0)
	es.set("sm_vote_show_votes_on", 1)
	es.set("sm_vote_sounds_on", 1)

	cmdlib.registerServerCommand("soccer_mod_vote_public", public, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_vote_show", show, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_vote_sounds", sounds, "Server Command")

	es.set("sm_vote_length", 30)
	es.set("sm_vote_delay", 10)

	cmdlib.registerServerCommand("soccer_mod_vote_length", length, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_vote_delay", delay, "Server Command")

	es.set("sm_vote_percentage_start_match", 75)
	es.set("sm_vote_percentage_stop_match", 50)
	es.set("sm_vote_percentage_start_cap", 75)

	cmdlib.registerServerCommand("soccer_mod_vote_percentage_start_match", percentage_start_match, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_vote_percentage_stop_match", percentage_stop_match, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_vote_percentage_start_cap", percentage_start_cap, "Server Command")

	es.set("sm_vote_sound_start", "soccer_mod/vote/prepare.mp3")

	cmdlib.registerServerCommand("soccer_mod_vote_sound_start", sound_start, "Server Command")

	addon.reg("sm_vote_command", "!vote", "soccer_mod_2011/modules/vote/cmd_vote")

	cmdlib.registerServerCommand("soccer_mod_vote_command", command, "Server Command")

# ******************** Commands ********************
def public(args):
	addon.boolean("sm_vote_public_on", args[0])

def show(args):
	addon.boolean("sm_vote_show_votes_on", args[0])

def sounds(args):
	addon.boolean("sm_vote_sounds_on", args[0])

def length(args):
	addon.integer("sm_vote_length", args[0], 5, 60, 30)

def delay(args):
	addon.integer("sm_vote_delay", args[0], 5, 60, 10)

def percentage_start_match(args):
	addon.integer("sm_vote_percentage_start_match", args[0], 0, 100, 75)

def percentage_stop_match(args):
	addon.integer("sm_vote_percentage_stop_match", args[0], 0, 100, 50)

def percentage_start_cap(args):
	addon.integer("sm_vote_percentage_start_cap", args[0], 0, 100, 75)

def command(args):
	addon.unreg("sm_vote_command")
	addon.reg("sm_vote_command", args[0], "soccer_mod_2011/modules/vote/cmd_vote")

def sound_start(args):
	es.set("sm_vote_sound_start", args[0])

# ******************** Unload ********************
def unload():
	cmdlib.unregisterServerCommand("soccer_mod_vote_public")
	cmdlib.unregisterServerCommand("soccer_mod_vote_show")
	cmdlib.unregisterServerCommand("soccer_mod_vote_sounds")

	cmdlib.unregisterServerCommand("soccer_mod_vote_length")
	cmdlib.unregisterServerCommand("soccer_mod_vote_delay")

	cmdlib.unregisterServerCommand("soccer_mod_vote_percentage_start_match")
	cmdlib.unregisterServerCommand("soccer_mod_vote_percentage_stop_match")
	cmdlib.unregisterServerCommand("soccer_mod_vote_percentage_start_cap")

	cmdlib.unregisterServerCommand("soccer_mod_vote_command")
	cmdlib.unregisterServerCommand("soccer_mod_vote_sound_start")

	addon.unreg("sm_vote_command")