import es
import keyvalues
import os

# ******************** Functions ********************
def refresh():
	file_name = "cstrike/cfg/soccer_mod/downloads.cfg"

	if os.path.isfile(file_name) != True:
		file = open(file_name, "w")
		file.close()

	if es.ServerVar("sm_downloads_auto_on") == 1:
		global downloads
		downloads = []

		try:
			os.remove(file_name)
		except OSError:
			error = 1

		global f
		f = open(file_name, "w")

		if es.ServerVar("sm_module_match_on") == 1:
			sounds = ["round_start", "round_end", "period_end", "match_end"]
			for item in sounds:
				add_sound("sm_match_sound_%s" % (item))

		if es.ServerVar("sm_module_referee_on") == 1:
			sounds = ["whistle", "red_card", "fireworks", "give_dope", "out_breath", "lightning", "cheer_leader_1", "cheer_leader_2", "cheer_leader_3"]
			for item in sounds:
				add_sound("sm_referee_sound_%s" % (item))

		if es.ServerVar("sm_module_scoreboard_on") == 1:
			models = ["model", "model_number"]
			for item in models:
				add_model(str(es.ServerVar("sm_scoreboard_%s" % (item))))

		if es.ServerVar("sm_module_shout_on") == 1:
			sounds = ["foul", "goal", "ole", "pass", "save", "shot"]
			for item in sounds:
				add_sound("sm_shout_sound_%s" % (item))

		if es.ServerVar("sm_module_skins_on") == 1:
			models = ["t", "ct", "t_gk", "ct_gk"]
			for item in models:
				add_model(str(es.ServerVar("sm_skins_%s" % (item))))

			skins = keyvalues.getKeyGroup("soccer_mod_skins")
			if skins != None:
				for item in skins:
					value = es.keygetvalue("soccer_mod_skins", item, "t")
					if value != "":
						add_model(value)

					value = es.keygetvalue("soccer_mod_skins", item, "ct")
					if value != "":
						add_model(value)

		if es.ServerVar("sm_module_training_on") == 1:
			add_model("models/%s" % (es.ServerVar("sm_training_model_ball")))

		if es.ServerVar("sm_module_vote_on") == 1:
			add_sound("sm_vote_sound_start")

		downloads.sort()
		for item in downloads:
			f.write(item)

		f.close()

	if int(es.ServerVar("sm_downloads_on")) == 1:
		es.server.cmd("exec soccer_mod/downloads.cfg")

def add_sound(sound):
	global downloads
	string = 'downloadable "sound/%s"\n' % (es.ServerVar(sound))
	if string not in downloads:
		downloads.append(string)

def add_model(value):
	words = value.split("/")

	dir = ""
	for i in range(0, len(words) - 1):
		dir += words[i] + "/"

	add_dir("materials/" + dir)
	add_dir(dir)

def add_dir(dir):
	path = "cstrike/%s" % (dir)
	for item in os.listdir(path):
		if os.path.isdir(path + "/" + item) != True:
			type = item.split(".")
			length = len(type) - 1
			if type[length] != "ztmp" and type[length] != "bz2":
				global downloads
				string = 'downloadable "%s%s"\n' % (dir, item)
				if string not in downloads:
					downloads.append(string)