﻿import es
import gamethread
import langlib
import playerlib
import popuplib
import random

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

common = langlib.Strings(lang_dir + "popup_common.ini")
messages = langlib.Strings(lang_dir + "modules/match/messages_match.ini")

# ******************** Load ********************
def load():
	create_popup_win()
	create_popup_lose()

# ******************** Create popup ********************
def create_popup_win():
	text = langlib.Strings(lang_dir + "modules/match/popup_match.ini")

	popup = popuplib.create("sm_popup_match_win")

	popup.addline("SOCCER MOD %s" % (text("title")))
	popup.addline(" ")
	popup.addline(text("beer"))
	popup.addline(" ")
	popup.addline("->1. %s" % (common("yes")))
	popup.addline("->2. %s" % (common("no")))
	popup.addline(" ")
	popup.addline("0. %s" % (common("close")))

	popup.select(1, beer)

	for i in range(3, 10):
		popup.submenu(i, "sm_popup_match_win")

def create_popup_lose():
	text = langlib.Strings(lang_dir + "modules/match/popup_match.ini")

	popup = popuplib.create("sm_popup_match_lose")

	popup.addline("SOCCER MOD %s" % (text("title")))
	popup.addline(" ")
	popup.addline(text("end"))
	popup.addline(" ")
	popup.addline("->1. %s" % (common("yes")))
	popup.addline("->2. %s" % (common("no")))
	popup.addline(" ")
	popup.addline("0. %s" % (common("close")))

	popup.select(1, fireworks)

	for i in range(3, 10):
		popup.submenu(i, "sm_popup_match_lose")

# ******************** Popup choice ********************
def beer(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)
	es.centertell(userid, messages("beer", tokens, player.get("lang")))

	change_view(userid)
	gamethread.delayed(0.2, change_view, (userid))
	gamethread.delayed(0.4, change_view, (userid))
	gamethread.delayed(0.6, change_view, (userid))
	gamethread.delayed(0.8, change_view, (userid))
	gamethread.delayed(1, change_view, (userid))
	gamethread.delayed(1.2, change_view, (userid))
	gamethread.delayed(1.4, change_view, (userid))
	gamethread.delayed(1.6, change_view, (userid))
	gamethread.delayed(1.8, change_view, (userid))
	gamethread.delayed(2, change_view, (userid))
	gamethread.delayed(2.2, change_view, (userid))
	gamethread.delayed(2.4, change_view, (userid))
	gamethread.delayed(2.6, change_view, (userid))
	gamethread.delayed(2.8, change_view, (userid))
	gamethread.delayed(3, change_view, (userid))
	gamethread.delayed(3.2, change_view, (userid))
	gamethread.delayed(3.4, change_view, (userid))
	gamethread.delayed(3.6, change_view, (userid))
	gamethread.delayed(3.8, change_view, (userid))
	gamethread.delayed(4, change_view, (userid))
	gamethread.delayed(4.2, change_view, (userid))
	gamethread.delayed(4.4, change_view, (userid))
	gamethread.delayed(4.6, change_view, (userid))
	gamethread.delayed(4.8, change_view, (userid))
	gamethread.delayed(5, change_view, (userid, 90))

def fireworks(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)
	es.centertell(userid, messages("fireworks", tokens, player.get("lang")))

	es.server.queuecmd("usermsg shake %s 100 2" % (userid))

	es.emitsound("player", userid, es.ServerVar("sm_referee_sound_fireworks"), "1.0", "0.5")

	push_player(userid, 5)
	gamethread.delayed(0.1, push_player, (userid, 20))
	gamethread.delayed(0.2, push_player, (userid, 45))
	gamethread.delayed(0.3, push_player, (userid, 80))
	gamethread.delayed(0.4, push_player, (userid, 125))
	gamethread.delayed(0.5, push_player, (userid, 180))
	gamethread.delayed(0.6, push_player, (userid, 245))
	gamethread.delayed(0.7, push_player, (userid, 320))
	gamethread.delayed(0.8, push_player, (userid, 405))
	gamethread.delayed(0.9, push_player, (userid, 500))
	gamethread.delayed(1, push_player, (userid, 605))
	gamethread.delayed(1.1, push_player, (userid, 720))
	gamethread.delayed(1.2, push_player, (userid, 845))
	gamethread.delayed(1.3, push_player, (userid, 980))
	gamethread.delayed(1.4, push_player, (userid, 1125))
	gamethread.delayed(1.5, push_player, (userid, 1280))
	gamethread.delayed(1.6, push_player, (userid, 1445))
	gamethread.delayed(1.7, push_player, (userid, 1620))
	gamethread.delayed(1.8, push_player, (userid, 1805))
	gamethread.delayed(1.9, push_player, (userid, 2000))

	gamethread.delayed(2.5, explosion, (userid))
	gamethread.delayed(2.5, kill_player, (userid))

# ******************** Functions ********************
def lang_msg(text, tokens, center = 0):
	for player in playerlib.getPlayerList("#human"):
		if center == 0:
			es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))
		else:
			es.centertell(player.userid, messages(text, tokens, player.get("lang")))

def win_t():
	for player in playerlib.getPlayerList("#t"):
		popuplib.send("sm_popup_match_win", player.userid)

	for player in playerlib.getPlayerList("#ct"):
		popuplib.send("sm_popup_match_lose", player.userid)

	end_match()

def win_ct():
	for player in playerlib.getPlayerList("#t"):
		popuplib.send("sm_popup_match_lose", player.userid)

	for player in playerlib.getPlayerList("#ct"):
		popuplib.send("sm_popup_match_win", player.userid)

	end_match()

def draw():
	if es.ServerVar("sm_match_golden_goal_on") == 1:
		es.set("golden_goal", 1)

		freeze_match()

		if es.ServerVar("sm_match_sounds_on") == 1:
			es.cexec_all("playgamesound", es.ServerVar("sm_match_sound_period_end"))

		tokens = {}
		lang_msg("draw", tokens)

		es.set("sm_match_first_hit", 1)

		es.server.queuecmd("mp_restartgame %s" % (es.ServerVar("sm_match_restart_length")))
	else:
		end_match()

def end_match():
	es.set("sm_match_started", 0)
	es.set("match_paused", 0)
	es.set("period_running", 0)
	es.set("period_break_running", 0)
	es.set("golden_goal", 0)
	es.set("seconds", 0)
	es.set("minutes", 0)
	es.set("period_break_running", 0)

	score_t = es.ServerVar("sm_match_score_t")
	score_ct = es.ServerVar("sm_match_score_ct")

	name_t = es.ServerVar("sm_match_short_name_t")
	name_ct = es.ServerVar("sm_match_short_name_ct")

	if es.ServerVar("sm_match_swap_names_on") == 0:
		score = "%s %s - %s %s" % (name_t, score_t, score_ct, name_ct)
	else:
		score = "%s %s - %s %s" % (name_ct, score_ct, score_t, name_t)

	tokens = {}
	tokens["score"] = score
	lang_msg("final_score", tokens)

	if es.ServerVar("sm_match_sounds_on") == 1:
		es.cexec_all("playgamesound", es.ServerVar("sm_match_sound_match_end"))

def change_view(userid, amount = 0):
	player = playerlib.getPlayer(userid)
	if player.isdead == 0:
		if amount == 0:
			amount = random.randint(1, 89)
		es.setplayerprop(userid, "CBasePlayer.m_iDefaultFOV", amount)

def push_player(userid, push):
	player = playerlib.getPlayer(userid)
	if player.isdead == 0:
		es.setplayerprop(userid, "CCSPlayer.baseclass.localdata.m_vecBaseVelocity", "0,0,%s" % (push))

def explosion(userid):
	player = playerlib.getPlayer(userid)
	if player.isdead == 0:
		es.emitsound("player", userid, "weapons/hegrenade/explode4.wav", "1.0", "0.5")
		x,y,z = es.getplayerlocation(userid)
		pos1 = "%s,%s,%s" % (x, y, z)
		es.server.queuecmd("es_xeffect sparks %s 9999 3 0,0,0" % (pos1))

def kill_player(userid):
	es.server.insertcmd("es_xsexec %s kill" % (userid))

def freeze_match():
	for ply in playerlib.getPlayerList("#alive"):
		ply.freeze(1)

	es.server.queuecmd("phys_pushscale 1")

	es.server.queuecmd("phys_timescale 0")

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_match_win")
	popuplib.delete("sm_popup_match_lose")