﻿import es
import gamethread
import langlib
import playerlib
import popuplib
import random

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

messages_common = langlib.Strings(lang_dir + "messages_common.ini")
messages_text = langlib.Strings(lang_dir + "modules/referee/messages_referee_punish.ini")
popup_common = langlib.Strings(lang_dir + "popup_common.ini")
popup_text = langlib.Strings(lang_dir + "modules/referee/popup_admin_referee_punish.ini")

hurt_sounds = [
	"vo/npc/barney/ba_ohshit03.wav",
	"vo/npc/barney/ba_pain01.wav",
	"vo/npc/barney/ba_pain02.wav",
	"vo/npc/barney/ba_pain03.wav",
	"vo/npc/barney/ba_pain04.wav",
	"vo/npc/barney/ba_pain05.wav",
	"vo/npc/barney/ba_pain06.wav",
	"vo/npc/barney/ba_pain07.wav",
	"vo/npc/barney/ba_pain08.wav",
	"vo/npc/barney/ba_pain09.wav",
	"vo/npc/barney/ba_pain10.wav",
	"vo/npc/male01/pain01.wav",
	"vo/npc/male01/pain02.wav",
	"vo/npc/male01/pain03.wav",
	"vo/npc/male01/pain04.wav",
	"vo/npc/male01/pain05.wav",
	"vo/npc/male01/pain06.wav",
	"vo/npc/male01/pain07.wav",
	"vo/npc/male01/pain08.wav",
	"vo/npc/male01/pain09.wav",
	"vo/npc/male01/ow01.wav"
]

# ******************** Load ********************
def load():
	popup = popuplib.create("sm_popup_admin_referee_punish")

	popup.addline("SOCCER MOD %s" % (popup_text("title")))
	popup.addline(" ")

	values = ["fireworks", "give_dope", "out_breath", "lightning", "cheer_leader", "clear_cheer_leader"]
	for i in range(0, len(values)):
		popup.addline("->%s. %s" % (i + 1, popup_text(values[i])))

	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (popup_common("close")))

	for i in range(1, 7):
		popup.select(i, popup_choice)

	for i in range(7, 9):
		popup.submenu(i, "sm_popup_admin_referee_punish")

	popup.submenu(9, "sm_popup_admin_referee")

	es.keygroupcreate("sm_keygroup_referee_cheer_leader")

# ******************** Events ********************
def es_map_start(event_var):
	es.keygroupcreate("sm_keygroup_referee_cheer_leader")
	es.keygroupdelete("sm_keygroup_referee_cheer_leader")

def player_spawn(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if int(event_var["es_userteam"]) > 1:
			if es.exists("key", "sm_keygroup_referee_cheer_leader", event_var["es_steamid"]) == 1:
				es.server.queuecmd("es_xgive %s player_weaponstrip" % (event_var["userid"]))
				es.server.queuecmd("es_xfire %s player_weaponstrip strip" % (event_var["userid"]))

				es.server.queuecmd("playerset color %s 255 255 255 150" % (event_var["userid"]))

				es.setplayerprop(event_var["userid"], "CCSPlayer.baseclass.baseclass.baseclass.baseclass.baseclass.baseclass.m_CollisionGroup", 2)

def player_say(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if int(event_var["es_userteam"]) > 1:
			if es.exists("key", "sm_keygroup_referee_cheer_leader", event_var["es_steamid"]) == 1:
				es.emitsound("player", event_var["userid"], es.ServerVar("sm_referee_sound_cheer_leader_%s" % (random.randint(1, 3))), 1, 0.5)

# ******************** Popup choice ********************
def popup_choice(userid, choice, name):
	tokens = {}
	player = playerlib.getPlayer(userid)

	popup_name = "sm_popup_%s" % (userid)
	if popuplib.exists(popup_name):
		popuplib.delete(popup_name)

	if choice < 6:
		if len(playerlib.getPlayerList("#alive")) > 0:
			myPopup = popuplib.easymenu(popup_name, None, punish)
			myPopup.settitle(messages_text("select_player"))

			for ply in playerlib.getPlayerList("#alive"):
				myPopup.addoption("%s_%s" % (choice, ply.userid), ply.name)

			myPopup.submenu(10, "sm_popup_admin_referee_punish")

			popuplib.send(popup_name, userid)
		else:
			es.tell(userid, "#green", messages_text("no_punish_dead", tokens, player.get("lang")))
			popuplib.send("sm_popup_admin_referee_punish", userid)
	else:
		if es.exists("keygroup", "sm_keygroup_referee_cheer_leader") == 1:
			es.keygroupdelete("sm_keygroup_referee_cheer_leader")

		tokens["name"] = player.name
		lang_msg("cleared_cheer_leaders", tokens)

		popuplib.send("sm_popup_admin_referee_punish", userid)

# ******************** Easymenu choice ********************
def punish(userid, choice, name):
	tokens = {}
	player = playerlib.getPlayer(userid)

	type_split = choice.split("_")
	punish = int(type_split[0])
	target = int(type_split[1])

	popup_name = "sm_popup_%s" % (userid)
	if popuplib.exists(popup_name):
		popuplib.delete(popup_name)

	if es.exists("userid", target) == 1:
		target = playerlib.getPlayer(target)
		if target.isdead == 0:
			tokens["name"] = player.name
			tokens["target"] = target.name

			if punish == 1:
				fireworks(target)
				lang_msg("fireworks", tokens)
			elif punish == 2:
				give_dope(target)
				lang_msg("give_dope", tokens)
			elif punish == 3:
				out_breath(target)
				lang_msg("out_breath", tokens)
			elif punish == 4:
				lightning(target)
				lang_msg("lightning", tokens)
			elif punish == 5:
				if es.exists("key", "sm_keygroup_referee_cheer_leader", target.steamid) == 0:
					cheer_leader(target)
					lang_msg("cheer_leader", tokens)
				else:
					es.tell(userid, "#green", messages_text("already_cheer_leader", tokens, player.get("lang")))
		else:
			es.tell(userid, "#green", messages_text("no_punish_dead", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages_common("no_player_found", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_referee_punish", userid)

# ******************** Functions ********************
def lang_msg(text, tokens):
	for player in playerlib.getPlayerList("#human"):
		es.tell(player.userid, "#green", messages_text(text, tokens, player.get("lang")))

def fireworks(choice):
	player_sound(choice, es.ServerVar("sm_referee_sound_fireworks"), 1, 0.5)

	player_shake(choice, 2, 100)

	player_push(choice, 5)
	gamethread.delayed(0.1, player_push, (choice, 20))
	gamethread.delayed(0.2, player_push, (choice, 45))
	gamethread.delayed(0.3, player_push, (choice, 80))
	gamethread.delayed(0.4, player_push, (choice, 125))
	gamethread.delayed(0.5, player_push, (choice, 180))
	gamethread.delayed(0.6, player_push, (choice, 245))
	gamethread.delayed(0.7, player_push, (choice, 320))
	gamethread.delayed(0.8, player_push, (choice, 405))
	gamethread.delayed(0.9, player_push, (choice, 500))
	gamethread.delayed(1, player_push, (choice, 605))
	gamethread.delayed(1.1, player_push, (choice, 720))
	gamethread.delayed(1.2, player_push, (choice, 845))
	gamethread.delayed(1.3, player_push, (choice, 980))
	gamethread.delayed(1.4, player_push, (choice, 1125))
	gamethread.delayed(1.5, player_push, (choice, 1280))
	gamethread.delayed(1.6, player_push, (choice, 1445))
	gamethread.delayed(1.7, player_push, (choice, 1620))
	gamethread.delayed(1.8, player_push, (choice, 1805))
	gamethread.delayed(1.9, player_push, (choice, 2000))

	gamethread.delayed(2.5, player_explosion, (choice))
	gamethread.delayed(2.5, player_sound, (choice, "weapons/hegrenade/explode4.wav", 1, 0.5))
	gamethread.delayed(2.5, player_kill, (choice))

def give_dope(choice):
	player_sound(choice, random.choice(hurt_sounds), 1, 0.5)

	gamethread.delayed(1.5, player_sound, (choice, es.ServerVar("sm_referee_sound_give_dope"), 1, 0.5))

	es.setplayerprop(choice, "CBasePlayer.m_iDefaultFOV", 155)

	player_shake(choice, 1, 100)
	gamethread.delayed(1.6, player_shake, (choice, 6.6, 25))

	gamethread.delayed(1.6, player_speed, (choice, 1.01))
	gamethread.delayed(1.7, player_speed, (choice, 1.02))
	gamethread.delayed(1.8, player_speed, (choice, 1.04))
	gamethread.delayed(2, player_speed, (choice, 1.08))
	gamethread.delayed(2.5, player_speed, (choice, 1.16))
	gamethread.delayed(3, player_speed, (choice, 1.32))
	gamethread.delayed(3.5, player_speed, (choice, 1.64))
	gamethread.delayed(4, player_speed, (choice, 2.28))
	gamethread.delayed(5, player_speed, (choice, 4.56))
	gamethread.delayed(7, player_speed, (choice, 9.68))

	es.server.queuecmd("usermsg fade %s 1 500 500 255 255 255 200" % (choice))

	gamethread.delayed(2, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(2.2, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(2.4, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(2.6, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(2.8, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(3, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(3.2, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(3.4, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(3.6, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(3.8, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(4, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(4.2, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(4.4, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(4.6, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(4.8, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(5, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(5.2, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(5.4, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(5.6, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(5.8, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(6, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(6.2, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(6.4, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(6.6, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(6.8, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(7, player_fade, (choice, 2, 100, 100))
	gamethread.delayed(7.2, player_fade, (choice, 1, 100, 100))
	gamethread.delayed(7.4, player_fade, (choice, 2, 400, 400))

	gamethread.delayed(8.2, es.setplayerprop, (choice, "CBasePlayer.m_iDefaultFOV", 90))
	gamethread.delayed(8.2, player_kill, (choice))

def out_breath(choice):
	player_sound(choice, es.ServerVar("sm_referee_sound_out_breath"), 1, 0.5)

	player_shake(choice, 6, 20)

	es.server.queuecmd("usermsg fade %s 2 3000 2000 0 0 0 255" % (choice))

	gamethread.delayed(0.5, player_speed, (choice, 0.95))
	gamethread.delayed(1, player_speed, (choice, 0.9))
	gamethread.delayed(1.5, player_speed, (choice, 0.85))
	gamethread.delayed(2, player_speed, (choice, 0.8))
	gamethread.delayed(2.5, player_speed, (choice, 0.75))
	gamethread.delayed(3, player_speed, (choice, 0.7))
	gamethread.delayed(3.5, player_speed, (choice, 0.65))
	gamethread.delayed(4, player_speed, (choice, 0.6))
	gamethread.delayed(4.2, player_speed, (choice, 0.5))
	gamethread.delayed(4.4, player_speed, (choice, 0.4))
	gamethread.delayed(4.6, player_speed, (choice, 0.3))
	gamethread.delayed(4.8, player_speed, (choice, 0.2))
	gamethread.delayed(5, player_speed, (choice, 0.175))
	gamethread.delayed(5.2, player_speed, (choice, 0.15))
	gamethread.delayed(5.4, player_speed, (choice, 0.125))
	gamethread.delayed(5.6, player_speed, (choice, 0.1))
	gamethread.delayed(5.8, player_speed, (choice, 0.075))
	gamethread.delayed(6, player_speed, (choice, 0.05))
	gamethread.delayed(6.2, player_speed, (choice, 0.025))

	gamethread.delayed(6.2, player_kill, (choice))

def lightning(choice):
	player_sound(choice, es.ServerVar("sm_referee_sound_lightning"), 1.0, 0.5)

	x,y,z = es.getplayerlocation(choice)
	pos1 = "%s,%s,%s" % (x, y, z)
	z += 2000
	pos2 = "%s,%s,%s" % (x, y, z)

	model = es.precachemodel("sprites/lgtning.vmt")

	es.server.queuecmd("es_effect beam %s %s %s %s 0 30 0.1 5 5 0 0 255 255 255 255 100" % (pos1, pos2, model, model))

	x,y,z = es.getplayerlocation(choice)
	pos1 = "%s,%s,%s" % (x, y, z)
	pos2 = "0,0,0"
	es.server.queuecmd("es_xeffect sparks %s 9999 3 %s" % (pos1, pos2))

	gamethread.delayed(0.1, player_kill, (choice))

def cheer_leader(choice):
	es.keycreate("sm_keygroup_referee_cheer_leader", es.getplayersteamid(choice))

	es.server.queuecmd("es_xgive %s player_weaponstrip" % (choice))
	es.server.queuecmd("es_xfire %s player_weaponstrip strip" % (choice))

	es.server.queuecmd("playerset color %s 255 255 255 150" % (choice))

	es.setplayerprop(choice, "CCSPlayer.baseclass.baseclass.baseclass.baseclass.baseclass.baseclass.m_CollisionGroup", 2)

def player_explosion(userid):
	player = playerlib.getPlayer(userid)
	if player.isdead == 0:
		x,y,z = es.getplayerlocation(userid)
		es.server.queuecmd("es_xeffect sparks %s,%s,%s 9999 3 0,0,0" % (x, y, z))

def player_push(userid, push):
	player = playerlib.getPlayer(userid)
	if player.isdead == 0:
		es.setplayerprop(userid, "CCSPlayer.baseclass.localdata.m_vecBaseVelocity", "0,0,%s" % (push))

def player_speed(userid, speed):
	player = playerlib.getPlayer(userid)
	if player.isdead == 0:
		player.setSpeed(speed)

def player_sound(userid, sound, volume, range):
	player = playerlib.getPlayer(userid)
	if player.isdead == 0:
		es.emitsound("player", userid, sound, volume, range)

def player_shake(userid, time, magnitude):
	player = playerlib.getPlayer(userid)
	if player.isdead == 0:
		es.server.queuecmd("usermsg shake %s %s %s" % (userid, magnitude, time))

def player_fade(userid, style, time, total):
	player = playerlib.getPlayer(userid)
	if player.isdead == 0:
		es.server.queuecmd("usermsg fade %s %s %s %s %s %s %s %s" % (userid, style, time, total, random.randint(0, 255), random.randint(0, 255), random.randint(0, 255), random.randint(100, 255)))

def player_kill(userid):
	es.server.insertcmd("es_xsexec %s kill" % (userid))

# ******************** Unload ********************
def unload():
	es.keygroupdelete("sm_keygroup_referee_cheer_leader")

	popuplib.delete("sm_popup_admin_referee_punish")